
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		anWindow;
	id		auShRow;
	id		basc;
	id		baux;
	id		haHa;
	id		wrule;
	id		ruleNumber;
	id		pslid;
	id		genEv;

	id		tiDat;
	id		valBx;
	id		varText;
	id		varWindow;
	id		wholePanel;
	
	id		ev1Window;
	id		ev2Window;
	id		ev3Window;

	id		menuCopy;
	id		menuPrint;

	id		theEvolView;
	id		thePlaidView;
	id		theShEvolView;
	id		theThEvolView;

	id		evolWindow;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	id		plaidWindow;
	
	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;

	id 		gridSize;
	id		aSwitch;

	id 		keepTop;
}

- drawEvolu:sender;
- drawPlEvol:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- evWindow:sender;

- printEvolu:sender;

- printPlain:sender;

- printShEvol:sender;
- printThEvol:sender;

		/* for plaid diagram  */
- drawPlaid:sender;
- printPlaid:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

@interface Object(PlotViewDelegate)
- PlotView:sender providePoints:(NXStream **)stream;
- PlotView:sender pointDidChange:(NXPoint *)aPoint;
@end

/* end LCAUView.m */
