
#import "RulePanel.h"
#import "nxlcau2s.h"
#import "rec.h"
#import <string.h> 
#import <time.h>
#import <ctype.h> 

# define NWOC	    13  /* number of symmetry classes w/o ctr	*/
# define TWIC	 NWOC*KK  /* number of symmetry classes w/ cntr	*/


extern char arule[DS], arr1[AL], arr2[AL];
extern binrular binrule;
extern int  co, dn;			/* connectivity, dimension */
extern ascrular ascrule;
extern ascrular auxrule;
       char gf2rule[13];		/*   coefficients of GF2 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK][SS];
extern char sarule[KK][SS];
extern char ixrule[NX][DS];
extern int     nr[NWOC];		/* nhd rep of sym class */


void definerule(unsigned long int n);
int longwolftoasc(char *c);

int     allperm(char wn[RSYM][WNML], ascrular ii[], ascrular *ru);
void    asctobin();
void    asctotot();
void	asczero();
void	auxzero();
void    bintoasc();
void    chrucopy(ascrular *ii, ascrular *jj, int c);
void    clumin(char *c);
int     cyy(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
void    grantotrule();
void    granptotrule();
int     istot();
int     isstot();
void    numtobin21(int ru[KK][KK][KK], int n);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(binrular *pr, binrular *br, int k);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p1, double p2);
void    ranplacor();
void    ransolcor();
void    ranvachrul(char *c);
void    rule24();
void	sttoasc();
void    stzero();
void    tazero();
void	totoasc();
int     totonu(int i);
void    ttzero();
void    wrru(char *c, ascrular *ru);   
int     vecperm(int ii[KK], int n);
int     ycc(int i);
void    zerline();

/*  declarations for REC  */
extern int rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
extern int rec(char *z);
 

/* declarations for arithmetic combinations   */
void bincopy(binrular *rz, int rx[KK][KK][KK][KK][KK]);
void binprint(binrular rz);
void binprod(binrular *rz, binrular rx, binrular ry);
void binsum(binrular *rz, binrular rx, binrular ry);
void byntoasc();
void rever3();
void rever2();
int allperm(char wn[RSYM][WNML], ascrular ii[], ascrular *ru);

char    xr[DS] = "12124010124120000010100010010101";
char    xp[DS] = "21241124112411241124112411241121";
char    xq[DS] = "13333333333333333333333333333332";

@implementation RulePanel

int permu[RSYM/2][KK] = {
			{0, 1},
			{1, 0}
			};

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */ 

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==toWindow)   nowBox=toBox;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender
{int i, j, k, i0, i1, i2, i3, i4;
//  i=j=[sender selectedCol];
//  i4=i%KK; i/=KK;
//  i3=i%KK; i/=KK;
//  i2=i%KK; i/=KK;
//  i1=i%KK; i/=KK;
//  i0=i%KK; i/=KK;
//  k=auxrule[i0][i1][i2][i3][i4];
//  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
//  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
// auxrule[i0][i1][i2][i3][i4]=!k;
return self;
}

- relatedRule:sender {
ascrular ii[RSYM]; char wnum[RSYM][WNML], c[WNML], *titl;
int l, k, j, jj[KK];
  k= 0;
  l= allperm(wnum,&ii[0],&ascrule);
  titl=[[sender selectedCell] title];
        if (strcmp(titl,"keep")==0)       k=0;
   else if (strcmp(titl,"complement")==0) k=1;
   else if (strcmp(titl,"cluster")==0)    k=RSYM;
   else if (strcmp(titl,"reflected")==0)  k=2;
   else if (strcmp(titl,"least")==0)      k=l;
   else if (strcmp(titl,"both")==0)       k=3;
   else					  k=0;
printf("relatedRule: k=%d\n",k);
   if (k==RSYM) {
     clumin(c);
     longwolftoasc(c);
     [self setAllRules: self];
     return self;
     }
   chrucopy(&ascrule,&ii[k],'w');
   [self setAllRules: self];
   if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
return self;
}    

/* report Wolfram rule number or variant */
void chrucopy(ii, jj, c) ascrular *ii, *jj; char c; {
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
  switch (c) {
    case 'w':
      for (i=0; i<DS; i++) ii->one[i]=jj->one[i];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) 
      for (i4=0; i4<KK; i4++) for (i5=0; i5<KK; i5++) 
      for (i6=0; i6<KK; i6++) for (i7=0; i7<KK; i7++) 
	ii->eight[i0][i1][i2][i3][i4][i5][i6][i7]=
	    ycc(jj->eight[cyy(i0)][cyy(i1)][cyy(i2)][cyy(i3)]
	                 [cyy(i4)][cyy(i5)][cyy(i6)][cyy(i7)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) 
      for (i4=0; i4<KK; i4++) for (i5=0; i5<KK; i5++) 
      for (i6=0; i6<KK; i6++) for (i7=0; i7<KK; i7++) 
	ii->eight[i0][i1][i2][i3][i4][i5][i6][i7]=
	    jj->eight[i7][i6][i5][i4][i3][i2][i1][i0];
      break;
    default: break;}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '0'; 
	case 0: return 1;
	case 1: return 0; 
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '0'; 
	case 0: return 1;
	case 1: return 0; 
	default:  return '0';}
}

void clumin(c) char *c; {
char d[WNML]; ascrular ii[RSYM]; char wnum[RSYM][WNML];
int  i, j, l;
  wrru(c,&ascrule);
  l=allperm(wnum,&ii[0],&ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(&ascrule,&ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,&ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

int vecperm(ii,n) int ii[KK], n; {int i,k,l;
  l=!(n<2); k=(l?n-2:n);
  switch (k) {
    case 0: for (i=0; i<KK; i++) ii[i]=i; break;
    case 1: for (i=0; i<KK; i++) ii[i]=ycc(i); break;
       default : for (i=0; i<KK; i++) ii[i]=i; break;}
  return l;
}

void ptedbrul(pr,br,k) binrular *pr, *br; int k; {int i;
  for (i=0; i<DS; i++) pr->one[i]=permu[k][br->one[i]];
}

int allperm(wn,ii,ru) char wn[RSYM][WNML]; ascrular ii[], *ru; {int k, l;
  chrucopy(&ii[0],&ascrule, 'w');
  chrucopy(&ii[1],&ascrule, 'y');
  chrucopy(&ii[2],&ascrule, 'r');
  chrucopy(&ii[3],&ii[2],   'y'); 
  for(k=0, l=0; k<RSYM; k++) {
	wrru(wn[k],&ii[k]);
	if (strlen(wn[k]) > strlen(wn[l])) continue;
	if (strlen(wn[k]) < strlen(wn[l])) { l=k; continue; }
	if (strcmp(wn[k],wn[l]) < 0) l=k;
  }
 return l;
}

/* - - - --  create the rule defined by the "symmetric rule" panel  - - - - */

- symRule:sender {return self;}

- readTRule:sender {
  nutoto([sender intValue]);
  totoasc();
  [self setAllRules: self];
return self;}

- readWRule:sender {char *c;
   c=[sender stringValue];
   if (longwolftoasc(c)) [self setAllRules: self];
   else
     [ruleNumber setStringValue:"Invalid"]; 
 return self;
}

int longwolftoasc (char *c) {
char d[WNML], e;
int i, i0, i1, i2, i3, i4, i5, l, n;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n = e- '0';
    else if ('a' <= e  &&  e <= 'f') n = e- 'a' + 10;
    else if ('A' <= e  &&  e <= 'F') n = e- 'A' + 10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) 
  for (i5=0; i5<KK; i5++) {
    n=d[(((((KK-i0)*KK-i1)*KK-i2)*KK-i3)*KK-i4)*KK-i5-1];
    ascrule.eight[i0][i1][i2][i3][i4][i5][0][0]='0'+n%KK; n/=KK;
    ascrule.eight[i0][i1][i2][i3][i4][i5][0][1]='0'+n%KK; n/=KK;
    ascrule.eight[i0][i1][i2][i3][i4][i5][1][0]='0'+n%KK; n/=KK;
    ascrule.eight[i0][i1][i2][i3][i4][i5][1][1]='0'+n%KK;
    }
  return TRUE;
}

void definerule(unsigned long int n)
{int i0, i1, i2, i3, i4;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++) {
//	ascrule[i0][i1][i2][i3][i4]='0'+ n%KK; n/=KK;
			 }
   
}

- setRule:sender 
{char ch[30]; int i, ii, j, jj, i0, i1, i2, i3, i4;
//   wrru(ch,ascrule);
//   [ruleNumber setStringValue: ch];
//   ii= [sender selectedRow];
//   jj=j= [sender selectedCol];   
//  i4=j%KK; j/=KK;
//  i3=j%KK; j/=KK;
//  i2=j%KK; j/=KK;
//  i1=j%KK; j/=KK;
//  i0=j%KK; j/=KK;
//  ascrule[i0][i1][i2][i3][i4]='0'+ii;
//  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
//  [[ascru cellAt: ii: jj] setIntValue: YES];
//  [self setAllRules: self];
  return self;
}  

- setAllRules:sender 
{char ch[WNML]; int i, j, i0, i1, i2, i3, i4;
//  wrru(ch,ascrule);
//  [ruleNumber setStringValue: ch];
 asctobin();
//  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) 
//   for (i3=0; i3<KK; i3++) for (i4=0; i4<KK; i4++) {
//  j=KK*(KK*(KK*(KK*i0+i1)+i2)+i3)+i4;
//  for (i=0; i<KK; i++) {
//      [[ascru cellAt: i: j] setIntValue: NO];
//      if (auxrule[i0][i1][i2][i3][i4]) [[ascru cellAt: i: j] setEnabled: NO];
//      if (auxrule[i0][i1][i2][i3][i4]) [[ascru cellAt: i: j] setBordered: NO];
//      }
//    [[ascru cellAt: binrule[i0][i1][i2][i3][i4]: j] setIntValue: YES];
//    }
//   wrru(ch,ascrule);
//   [ruleNumber setStringValue: ch];
   [probView loadProb: self];
   [self showProbability: pSliders];
   if      (istot()) {
		asctotot();
		[totlRef setStringValue: "Totalistic"]; 
		[self setTotRules: self];
		}
   else if (isstot()) [totlRef setStringValue: "Semitotalistic"];
   else {
	wrru(ch,&ascrule);
	[toFullNumber setStringValue: ch];
	[toascru setEmptySelectionEnabled: YES];
	[toascru selectCellAt: -1: 0];
	for (j=0; j<TS; j++) for (i=0; i<KK; i++) 
		[[toascru cellAt: i: j] setIntValue: NO];
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {int i;
  for (i=0; i<DS; i++) ascrule.one[i]='0';
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* for 2-state automata, group the neighborhoods by fours and  */
/* use ASCII letters base 16 - that is, 0-9, A-F.	       */
void wrru(c,ru) char *c; ascrular *ru; {
int  i, j;
int  i0, i1, i2, i3, i4, i5;
  j=0;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++) {
    i= 4*(2*(ru->eight[i0][i1][i2][i3][i4][i5][1][1]-'0')+
            (ru->eight[i0][i1][i2][i3][i4][i5][1][0]-'0'))+
          2*(ru->eight[i0][i1][i2][i3][i4][i5][0][1]-'0')+
            (ru->eight[i0][i1][i2][i3][i4][i5][0][0]-'0')+'0';
    if (i>'9') i=i+('A'-':');
    c[WNML-j-2]=i;
    j++;
    }
  c[WNML-1]=0;
}

/* for 2-state automata, group the neighborhoods by fours and  */
/* use ASCII letters base 16 - that is, 0-9. A-H	       */
void wru(c) char *c; {wrru(c,ascrule.one);}

/* generate a random rule */
void granrule() {int i;
for (i=0; i<DS; i++) ascrule.one[i]=(random()&0xFF)%KK+'0';
}

/* generate a random protected rule */
void granprule() {int i, j;
i=0; j=0;
for (i=0; i<DS; i++) {
  if (i%8 == 0) j=random(); i++;
  if (auxrule.one[i]==0) ascrule.one[i]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- rCellLine:sender
{double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1]);
return self;
}

- sCellLine:sender {
  zerline();
  switch (dn) {
    case 1: putionj(1,0); break;
    case 2: ranplacor(); break;
    case 3: ransolcor(); break;
    case 5: ranplacor(); break;
    case 6: ransolcor(); break;
    default: putionj(1,0); break;}
return self;
}

- uCellLine:sender {ranblin(0.5,0.5); return self;}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {unsigned long int b;  /*   char ch[20];   */
  b=[[sender selectedCell] tag];
   definerule(b); 
   [self setAllRules: self]; 
  return self;
}

/* - - - - - - - - - - - - -   G F ( 2 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf2rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF2Rule:sender {
//   int i; for (i=0; i<13; i++) printf("%1d ",gf2rule[i]); printf("\n");
    gftoasc();
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender {
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    strule[t%KK][t/KK]=s+'0';
    [toWindow setDocEdited:YES];
 /*   sttoasc();   */
  return self;
  }
 
- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited:YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited:NO];
return self;
}

- protectTotRule:sender {int i, j, k;
    j=[sender selectedCol];
    k=tarule[j];
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setEnabled:  k];
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setBordered: k];
    tarule[j]=!k;
return self;
}

- setTotRule:sender {char ch[WNML]; int i, ii, jj;
  wrru(ch,&ascrule);
  [ruleNumber setStringValue: ch];
  ii= [sender selectedRow];
  jj= [sender selectedCol];
  ttrule[jj]='0'+ii;
  for (i=0; i<KK; i++) [[toascru cellAt: i: jj] setIntValue: NO];
  [[toascru cellAt: ii: jj] setIntValue: YES];
  [self setTotRules: self];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
//  wrru(ch,&ascrule);
//  [ruleNumber setStringValue: ch];
  totoasc();
  asctobin();
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  wrru(ch,&ascrule);
  [toFullNumber setStringValue: ch];
  [probView loadProb: self];
   if      (istot()) {
		asctotot();
		[totlRef setStringValue: "totalistic"];
		[toRuleNumber setIntValue: totonu(0)];
		}
    else if (isstot()) [totlRef setStringValue: "semitotalistic"];
    else        [totlRef setStringValue: " "];
return self;
}

- freeAllTotRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    tazero();
return self;
}

- zeroTotRules:sender 
    {ttzero(); tazero(); totoasc(); [self setTotRules: self]; return self;}

- ranTotRules:sender {grantotrule(); [self setTotRules: self]; return self;}

- ranPTotRules:sender {granptotrule(); [self setTotRules: self]; return self;}

/* generate a random protected totalistic rule */
void granptotrule() 
  {int i; for (i=0; i<TS; i++) if (tarule[i]==0) ttrule[i]='0'+random()%KK;}

/* generate a random totalistic rule */
void grantotrule() {int i; for (i=0; i<TS; i++) {ttrule[i]='0'+random()%KK;}}

/* clear ttrule to zeroes */
void ttzero() {int i; for (i=0; i<TS; i++)  ttrule[i]='0';}

/* clear tarule to zeroes */
void tazero() {int i; for (i=0; i<TS; i++)  tarule[i]=0;}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophilic:sender {
//  oxtoasc(xr);
  ranvachrul(xp);
  [self setAllRules: self];
return self;
}

- xenophobic:sender {
//  oxtoasc(xr);
  ranvachrul(xq);
  [self setAllRules: self];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule */
void ranvachrul(c) char *c; {int i0, i1, i2, i3, i4, i;
i=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) 
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++){
  switch (c[KK*(KK*KK*(KK*i0+i1)+(KK*i2+i3))+i4]-'0') {
    case 0: break;
    case 1: i=0; break;
    case 2: i=1; break;
    case 3: i=ran2of3(0,1); break;
 /*   case 4: i=ran2of3(0,1); break;
    case 5: i=ran2of3(1,2); break;
    case 6: i=ran2of3(2,0); break;
    case 7: i=ran3of3(0,1,2); break;    */
    default: i=0; break;}
//    ascrule[i0][i1][i2][i3][i4]='0'+i;
  }
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
//    [z setIntValue: (int)ascrule[i0][i1][i2]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2, i3, i4;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i4=k%KK; k/=KK;
    i3=k%KK; k/=KK;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
//    ascrule[i0][i1][i2][i3][i4]=(k<KK?k:0)+'0';
//    auxrule[i0][i1][i2][i3][i4]=(k<KK?1:0);
    }
  [self setAllRules: self];
return self;
}

/* - - - - - - -    A R I T H M E T I C    C O M B I N A T I O N   - - - - - */

 - arithmCombs:sender {
int i0, i1, i2, i3, i4;
// binrular aza, bzb, czc;
//    [self readWRule: [twoRules cellAt: 0: 0]];
//    asctobin();
//    bincopy(&aza,binrule);
//    binprint(aza);
//    [self readWRule: [twoRules cellAt: 1: 0]];
//    asctobin();
//    bincopy(&bzb,binrule);
//    binprint(bzb);
//    switch ([sender selectedRow]) {
//       case 0: binsum(&czc,aza,bzb); break;
//       case 1: binprod(&czc,aza,bzb); break;
//       default: printf("arithCombs\n"); 
//    break;}
//    binprint(czc);
//    for (i0=0; i0<KK ;i0++) 
//       for (i1=0; i1<KK ;i1++) 
// 	 for (i2=0; i2<KK ;i2++) 
// 	    for (i3=0; i3<KK; i3++)
// 	      for (i4=0; i4<KK; i4++)
//                binrule[i0][i1][i2][i3][i4]=czc.eight[i0][i1][i2][i3][i4]; 
//    bintoasc();
//    [self setAllRules: self];
return self;
}

- initTwoRules:sender {
// char ch[20];
//    granrule();
//    wrru(ch,ascrule);
//    [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
return self;
}

/* copy one binary rule from another */
// void bincopy(rz,rx) binrular *rz; int rx[KK][KK][KK][KK][KK];
// {int i0, i1, i2, i3, i4;
//    for (i0=0; i0<KK; i0++)
//       for (i1=0; i1<KK; i1++)
//          for (i2=0; i2<KK; i2++)
//             for (i3=0; i3<KK; i3++)
//               for (i4=0; i4<KK; i4++)
//                rz->eight[i0][i1][i2][i3][i4]=rx[i0][i1][i2][i3][i4]+'0';
// }


/*  fill ascrule from binrule */
void byntoasc(as, bi) ascrular *as; binrular *bi;
{int i; for(i=0; i<DS; i++) as->one[i] = bi->one[i] + '0';}


/* fill ascrule from binrule*/
void bintoasc()
{int i; for(i=0; i<DS; i++) ascrule.one[i] = binrule.one[i] + '0';}

/*sum two binary rules mod KK*/
void binsum(rz,rx,ry) binrular *rz, rx, ry;
{int i; for (i=0; i<K5; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*multiply two binary rules mod KK*/
void binprod(rz,rx,ry) binrular *rz, rx, ry;
{int i; for (i=0; i<K5; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*print a binary rules (all 16 numbers)*/
void binprint(rz) binrular rz;
{int i;
      for (i=0; i<KK*KK*KK*KK*KK; i++) printf("%c",rz.one[i]+'0');
      printf("\n");
}

/* - - - - - - - - - - -  C O M P O S I T E   R U L E  - - - - - - - - - - */ 

- composRule:sender
{ int ru1, ru2, i0, i1, i2, i3, i4, br1[KK][KK][KK], br2[KK][KK][KK];
  ru1=[[composRuleNumb cellAt: 0: 0] intValue];
  ru2=[[composRuleNumb cellAt: 1: 0] intValue];
// numtobin21(br1, ru1);
// numtobin21(br2, ru2);
// for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) 
// for (i3=0; i3<KK; i3++) for (i4=0; i4<KK; i4++)
// ascrule[i0][=br2[br1[i0][i1][i2]][br1[i1][i2][i3]][br1[i2][i3][i4]] + '0';
// [self setAllRules:self];
return self;
}

- compxRule:sender { int i;
//   i=[[composRuleNumb cellAt: 0: 0] intValue];
//   [[composRuleNumb cellAt: 0: 0] setIntValue: [[composRuleNumb cellAt: 1: 0]
//   intValue]];
//   [[composRuleNumb cellAt: 1: 0] setIntValue: i];
 return self;
}

- comprRule:sender { 
  [[composRuleNumb cellAt:0 :0] setIntValue: random()%255];
  [[composRuleNumb cellAt:1 :0] setIntValue: random()%255];
return self;
}


void numtobin21(ru,n) int ru[KK][KK][KK], n;
{ int i, j, i0, i1, i2;
i=n;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++){
j=i%KK; i/=KK;
ru[i0][i1][i2]=j;
    }
}


/* - - - - - - - - special rule box management - - - - - - - - */


- loadSpecialRule:sender
{
  char *ch;
 ch=(char *) malloc(strlen([[sender selectedCell] title]));
 strcpy(ch,[[sender selectedCell] title]);
 if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
 if (strcmp(ch,"hexagonal")==0)  [self loadLowerPanel: hexLatBox];
 if (strcmp(ch,"composite")==0)   [self loadLowerPanel:composRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox
{ NXRect bxRect, loRect;
  [specBigBox  getFrame:&bxRect];
  [thisRuleBox getFrame:&loRect];
  [specBigBox  setContentView: [thisRuleBox contentView]];
  loRect.origin.x = (bxRect.size.width - loRect.size.width)/2.0;
  loRect.origin.y = (bxRect.size. height - loRect.size.height)/2.0;
  [specLilBox setFrame: &bxRect];
  [specLilBox display];
  [specBigBox display];
 return self;
}

@end

/* clear srule to zeroes */
void stzero() {int i, j;
  for (i=0; i<KK; i++) for (j=0; j<TS-1; j++)  strule[i][j]='0';
}

/* clear gf2rule to zeroes */
void gfzero() {int i; for (i=0; i<13; i++) gf2rule[i]='0';}


/* clear auxrule to zeroes */
void auxzero() {int i; for (i=0; i<DS; i++) auxrule.one[i]=0;}

/* generate a random line of cells in arr1 with assigned probabilities */
void ranblin(p1, p2) double p1, p2; {
int    i, c, i1;
double p;
  p=p1+p2;
  i1=(int)((1000.0*p1)/p);
 /* i2=i1+(int)((1000.0*p2)/p);   */
  for (i=0; i<AL; i++) {
    c=random()%1000;
    if (c<i1) arr1[i]=0; /*else if (c<i2) arr1[i]=1;*/ else arr1[i]=1;
    }
}

/* change a GF2 rule to general rule */
void gftoasc() {} 
 
int ufmult() {
int i, m[KK];
asctobin();
for (i=0; i<KK; i++) m[i]=0;
for (i=0; i<DS; i++) m[binrule.one[i]]++;
for (i=1; i<KK; i++) if (m[i]!=m[0]) return 0;
return 1;
}

/* end RulePanel.m */
