
/* 
 * SQULView.h -- Interface file for the SQULView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface SQULView:View {

	id		keyWindow;
	id		bernView;
	id		GolayPanel;
	id		GolayView;
	id		planeView;
	id		planeWindow;
	id		SqulView;
	id		SqulWindow;
	id		rtrnView;
	id		rtrnWindow;
	id		squlView;
	id		squlWindow;
	id		trajView;
	id		trajWindow;

	id		theZMatrix;
	id		theOMatrix;
	id		theToMatrix;
	id		mMent;
	id		reStore;
	id		genEv;
	id		moSaic;
	id		moTies;
	id		probDots;

	id		rulePanel;
	id		ruleNumber;
	id		ruleType;
	id		pSliders;
	id		pWindows;
	id		tRuleNumber;
	id		xsRuleNumber;

	id		menuCopy;
	id		menuPrint;

	id		tiTime;
	id		tiDat;

	id		delegate;
	id		crossCursor;

}

- checkerBoard:sender;
- copyRule:sender;
- copyTRule:sender;
- drawBern:sender;
- drawFreq:sender;
- drawMosaic:sender;
- drawPlEvol:sender;
- drawRtrn:sender;
- drawSmEvol:sender;
- drawSmMosaic:sender;
- drawTraj:sender;
- enterRule:sender;
- enterTRule:sender;
- loadSqul:sender;
- printFreq:sender;
- printMosaic:sender;
- printPlEvol:sender;
- printRtrn:sender;
- printRule:sender;
- printSlowFreq:sender;
- printSmEvol:sender;
- printSmMosaic:sender;
- printTraj:sender;
- randomLine:sender;
- readRule:sender;
- readTRule:sender;
- resetRule:sender;
- sCellLine:sender;
- showProbability:sender;
- slowFreq:sender;
- uniformLine:sender;

- uprule:sender;
- lerule:sender;
- dorule:sender;
- rirule:sender;
- idrule:sender;
- mjrule:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end SQULView.h */
