
/* demo2s.c					*/
/* (2,3) Linear Cellular Automaton		*/
/* demonstration module (including rec demos)	*/
/* Harold V. McIntosh, January 30, 1991		*/

# include "lcau2s.h"
# include "keybrd.h"

extern int    di, dj, dij;	/* demo pointer */
extern int    sl;		/* screen line */
extern int    rij, rdi, rdj;	/* rec demo pointers */
extern int    pr1, pr2;		/* product rule */
extern int    ir1, ir2;		/* reversible rule */
extern int    pxl;		/* pixel color */
extern int    cgy;		/* category pointer */
extern int    iru;		/* invertible rule number */
extern int    rp, rq;					/* source code in cstr */
extern char   ascrule[KK][KK][KK][KK][KK][KK][KK];	/* ASCII transition values */
extern char   arr1[AL], arr2[AL];			/* line of cells */
extern int    aptr;					/* arr1 pointer for rec */

struct fptbl {			/* structure of predicate table */
	int	(*cfun)();	/* compiling function */
	int	(*xfun)();	/* executing function */
	char	*r_cmnt;	/* comment describing function */
};

extern struct fptbl dtbl[];

extern long int r_intpar;

char demotabl[][HCH]= {
  " 1                           ",
  " 2                           ",
  " 3                           ",
  " 4                           ",
  " 5                           ",
  " 6                           ",
  " 7                           ",
  " 8                           ",
  " 9                           ",
  "10                           ",
  "11                           ",
  "12                           ",
  "13                           ",
  "14                           ",
  "15                           ",
  "16                           ",
  "17                           ",
  "18                           ",
  "19                           ",
  "20                           ",
  "21                           ",
  "22                           ",
  "23                           ",
  "24                           ",
  "25                           ",
  "26                           ",
  "27                           ",
  "28",
  "29",
  "30",
  "31",
  "32",
  "33",
  "34",
  "35",
  "36",
  "37",
  "38",
  "39",
  "40",
};

/* list of demonstration rules 			  */
/* n is key which entered menu, also used to exit */

int dmenu(n) int n; {int i, di, dj; char c;
videomode(T80X25);
videocursor(0,0,0); printf("Demonstration rules for LCAU2S");
for (i=0; i<DROWS; i++) {videocursor(0,i+1,0); printf(&demotabl[i]);}
for (i=DROWS; i<NX; i++) {videocursor(0,i-DROWS+1,DCOLS); printf(&demotabl[i]);}
videocursor(0,22,0); printf("move cursor with arrows, select with <cr>");
videocursor(0,22,42); printf("activate with insert");
videocursor(0,23,0); printf("position at top with <, bottom with >.");
  di=dij%DROWS; dj=(dij<DROWS?1:DROWS);
  do {
    videocursor(0,di+1,dj);
    while (!kbdst()) videocursor(0,di+1,dj);
    c=kbdin();
      switch (c) {
      case '\013': case MOU: di=(DROWS+di-1)%DROWS; break; 	     /* up arrow      */
      case '\012': case MOD: di=(DROWS+di+1)%DROWS; break; 	     /* down arrow    */
      case '\014': case MOR: case ' ': dj=(dj==1?DCOLS:1); break;    /* forward       */
      case BAK: case MOL: dj=(dj==1?DCOLS:1); break;		     /* backward      */
      case '<': case PGU: di=0; break;				     /* home	      */
      case '>': case PGD: di=DROWS-1; break;			     /* bottom	      */
      default: break;
      }
    } while ((c!='\015')&&(c!=MOX)&&(c!=n));
  videomode(T80X25);
  return(di+(dj==1?0:DROWS));
/*  dij=di+(dj==1?0:DROWS); */
}

char recrule[NY][48]= {
  "(;;)",						/*  1 - null program - for editing */
  "( (gpEk :;) ;)",					/*  2 - 3 panel run on		   */
  "(O3 $97$ T zA fb fc dc x2 ~ (gpEk :;) ;)",		/*  3 - triangle demo              */
  "(O1 o2 $33$ T fc dc x2 (n K g k :;)   ;)",		/*  4 - init hiplot   ples by 8's  */
  "( (gk :;) ;)",					/*  5 - running evol  		   */
  "( fH dH ;                            ;)",		/*  6 - init hiplot   ples by 8's  */
  "(      ;)",						/*  7 -               d evolution */
  "(                      ;)", 				/*  8 - */
  "(                      ;)",				/*  9 - */
  "(                      ;)",				/* 10 - */
  "{(        ;) a (                          ;)}",	/* 11 -               es I  */
  "{(        ;) a (                          ;)}",	/* 12 -               es II */
  "(;;)",						/* 13 - */
  "(;;)"						/* 14 - */
};

char drectabl[][HCH]= {
  " 1 - null program - for editing",
  " 2 - 3-panel: run indefinitely ",
  " 3 - O3 triangle comprehensive ",
  " 4 - contours of ttl-mf mixture",
  " 5 -                           ",
  " 6 - draw hiplot frame         ",
  " 7 -                           ",
  " 8 -                           ",
  " 9 -                           ",
  "10 -                           ",
  "11 -                           ",
  "12 -                           ",
  "13 -                           ",
  "14 -                           ",
  "15 -                           ",
  "16 -                           ",
  "17 -                           ",
  "18 -                           ",
  "19 -                           ",
  "20 -                           ",
};

/* list of rec based demonstrations rules */
int recdem(n) int n; {int i, ii, jj; char c;
videomode(T80X25);
videocursor(0,0,0); printf("REC demonstrations for LCAU2S");
for (i=0; i<DROWS; i++) {videocursor(0,i+1,0); printf(&drectabl[i]);}
videocursor(0,22,0); printf("move cursor with arrows, select with <cr>");
videocursor(0,23,0); printf("position at top with <, bottom with >.");
  ii=RROWS; jj=RCOLS; c='!';
  do {
    videocursor(0,rdi+1,rdj);
    while (!kbdst()) videocursor(0,rdi+1,rdj);
    c=kbdin();
      switch (c) {
      case '\013': case MOU: if (rdi==0) rdi=ii-1; else rdi--; break; /* up arrow */
      case '\012': case MOD: if (rdi==ii-1) rdi=0; else rdi++; break; /* down arrow */
      case '\014': case MOR: case ' ': rdj=(rdj==1?jj:1); break;      /* forward */
      case '\010': case MOL: rdj=(rdj==1?jj:1); break;		      /* backward */
      case '<': case PGU: rdi=0; break;				      /* home */
      case '>': case PGD: rdi=ii-1; break;			      /* bottom */
      default: break;
      }
    } while (c!='\015' && c!=n);
  videomode(T80X25);
  rij=rdi+(rdj==1?0:ii);
  return(rij+1);
}

char recsy[][HCH]= {
  "- rec expression syntax - ",
  "expression = (op:ooe:;)   ",
  "program = {(.)x(..@x..)}  ",
  "lparen begins subexprssn  ",
  "rparen ends subexpn with F", 
  "colon repeats subexprn    ",
  "semicolon exits with T    ", 
  "operators continue        ",
  "predicates skip           ",
  "F pred exits T if no :,;  ", 
  "braces enclose defs, main ",
  "main is last exp w/o label",
  "pred @x executes defined x",
};

char reedop[][HCH]= {
  "to edit a rec program:    ",
  "  arrows move cursor      ",
  "  INS creates a space     ",
  "  BS, DEL backspace, erase",
  "  BEG, END position cursor",
  "  ASCII chars displace    ",
  "  f1, f2 show help panels ",
  "  f3 shows character def  ",
  "  f4 executes at once     ",
  "  CR returns to main menu ",
};


/* generic help panel - text mode, right hand panel */
gmenu(menu,n) char menu[][HCH]; int n; {int i;
videoscroll(10,40,22,79,0,5);
for (i=0; i<n; i++) {videocursor(0,i+9,44); printf("%0.26s",&menu[i]);}
}

/* ------------------------------------------------------------ */
/* -	    edrec, which is used to edit rec programs	      -	*/
/* ------------------------------------------------------------ */

/* edit a line of rec code, which will be shown at the bottom */
/* of the main screen. Once edited, the line will be executed */

edrec(rcs) char *rcs; {int n; char cc;
  n=0;
  txtmode();
  edrecclr();
  edrecini(rcs);
  rq=rp; videocursor(0,23,rp);

  while (0<1) {
    edrecpdef(rcs[rq]); videocursor(0,23,rq);
    cc=kbdin();
    if (cc=='\015' || cc==Kf3) break;
    switch (cc) {
      case MOR: if (rq<rp) rq++; break; 
      case MOL: if (rq>0) rq--; break; 
      case PPU: rq=0; break;
      case PPD: rq=rp; break;
      case PGU: n=(8+n-1)%8; edrecoppr(n); break;
      case PGD: n=(8+n+1)%8; edrecoppr(n); break;
      case BAK: edrecbak(rcs); break; 
      case INS: edrecins(rcs); break;		/* make way		    */
      case DEL: edrecdel(rcs); break;
      case Kf1: gmenu(reedop,10); break;	/* keyboard option menu	    */
      case Kf2: gmenu(recsy,13); break;		/* function key menu        */
      case Kf4: rec(rcs); edrecini(rcs); break;	/* f4 = execute rec program */
      default:  edrecchar(rcs,cc); break;
      } /* end switch */
    videocursor(0,23,rq);
    }   /* end while */
  edrecclr();
  videocursor(0,5,0);
}       /* end edrec */

edrecpdef(c) char c; {videocursor(0,21,0); printf("%0.33s",dtbl[c-' '].r_cmnt);}

edrecphl() {videocursor(0,22,0); printf("edit REC program:");}

edrecplin(rcs) char *rcs; {int i;
  for (i=0; i<CLEN; i++) {
    if (rcs[i]==0) break;
    videocursor(0,23,i); printf("%c",rcs[i]);
    }
  rp=i;	/* naughty, naughty */
}

edrecini(rcs) char *rcs; {edrecphl(); edrecplin(rcs);}

edrecclr() {videoscroll(21,0,23,70,0,3); videoscroll(9,40,22,79,0,3);}

edrecbak(rcs) char *rcs; {int i;
  if (rq==0) return; 
  if (rp==rq) {rq--; rp--; videocursor(0,23,rq); 
  printf(" "); rcs[rq]=0; return;}
  i=rq-1; do {rcs[i]=rcs[i+1]; videocursor(0,23,i); 
  printf("%c",rcs[i]); i++;} while (i<rp); rp--;
  rcs[rp]=0; videocursor(0,23,rp); printf(" "); rq--;
}

edrecdel(rcs) char *rcs; {int i;
  if (rp==rq) return;
  i=rq; do {rcs[i]=rcs[i+1]; videocursor(0,23,i); 
  printf("%c",rcs[i]); i++;} while (i<rp); rp--;
  rcs[rp]=0; videocursor(0,23,rp); printf(" ");
}

edrecins(rcs) char *rcs; {int i;
  if (rp>=CLEN-1) return;
  rp++; i=rp; do {rcs[i]=rcs[i-1]; videocursor(0,23,i);
  printf("%c",rcs[i]); i--;} while (i>rq); rcs[rq]=' ';
  videocursor(0,23,rq); printf(" ");
}

edrecchar(rcs,cc) char *rcs,cc; {
  if (cc<' ') return;
  if (cc>'~') return;
  edrecins(rcs);
  if (rq<rp) {
    rcs[rq]=cc;
    videocursor(0,23,rq); printf("%c",rcs[rq]);
    rq++; return;
    } else if (rp<CLEN-1) {
      rp++;
      rcs[rp]=0; 
      rcs[rq]=cc;
      videocursor(0,23,rq); printf("%c",rcs[rq]);
      rq++;
      }
}

edrecoppr(n) int n; {int i, j;
videoscroll(10,40,22,79,0,3);
for (i=0; i<12; i++) {
  j=12*n+i; if (j==0) continue; if (j==96) continue;
  videocursor(0,11+i,44); printf("%0.33s",dtbl[j].r_cmnt);}
}

/* ------------------------------------------------------------ */

/* end demo2S.c */
